using Library;
using MySystem.PxcModels;
using System;
using System.Linq;

namespace MySystem
{
    public class ConsumerOpenIdsHelper
    {
        public readonly static ConsumerOpenIdsHelper Instance = new ConsumerOpenIdsHelper();
        private ConsumerOpenIdsHelper()
        { }

        public string Start()
        {
            bool op = true;
            WebCMSEntities db = new WebCMSEntities();
            string result = "";
            int total = 0;
            while (op)
            {
                ConsumerOpenIds PopData = new ConsumerOpenIds();
                try
                {
                    //获取apserver待同步的数据，执行入库
                    PopData = RedisDbconn.Instance.RPop<ConsumerOpenIds>("Pop:ConsumerOpenIds");
                    if (PopData != null)
                    {
                        ConsumerOpenIds checkExist = db.ConsumerOpenIds.FirstOrDefault(m => m.OpenId == PopData.OpenId);
                        if (checkExist != null)
                        {
                            checkExist = PopData;
                        }
                        else
                        {
                            db.ConsumerOpenIds.Add(PopData);
                        }
                        total += 1;
                        if (total >= 20)
                        {
                            total = 0;
                            db.SaveChanges();
                        }
                        if (string.IsNullOrEmpty(result)) result = "success";
                    }
                    else
                    {
                        if (total > 0)
                        {
                            db.SaveChanges();
                        }
                        op = false;
                    }
                }
                catch (Exception ex)
                {
                    ErrorMsg msg = new ErrorMsg();
                    msg.Obj = PopData;
                    msg.Time = DateTime.Now;
                    msg.ErrorContent = ex.ToString();
                    Utils.WriteLog(Newtonsoft.Json.JsonConvert.SerializeObject(msg), "Pop:ConsumerOpenIds:Error");
                    result = "有异常，请查看Pop:ConsumerOpenIds:Error队列";
                }
            }
            db.Dispose();
            return result;
        }
    }
}